#include "game.h"

game_t * gameInit(char *gameName) {
  // Create the game instance
  game_t *game = malloc(sizeof(game_t));
  if(game == NULL) return NULL;

  // Setup the renderer
  game->render = renderInit(gameName);
  if(game->render == NULL) {
    free(game);
    return NULL;
  }

  // Load a shader
  shader_t *shader = assetShaderLoad("shaders/test.vert", "shaders/test.frag");
  if(shader == NULL) {
    printf("Shader loading failed\n");
  } else {
    printf("Shader loaded!\n");
  }

  return game;
}

void gameStart(game_t *game) {
  while(!glfwWindowShouldClose(game->render->window)) {
    renderFrame(game->render);
    
    glfwSwapBuffers(game->render->window);
    glfwPollEvents();
  }
}

bool gameDispose(game_t *game) {
  if(!renderDispose(game->render)) return false;
  free(game);

  return true;
}